<template>
  <fieldset>
    <CheckboxBorderedLabel :text="t('show_column_headers_label')" for="showColumnHeaders">
      <input
          type="checkbox"
          name="showColumnHeaders"
          id="showColumnHeaders"
          :checked="currentSettings.showColumnHeaders"
      />
    </CheckboxBorderedLabel>
    <CheckboxBorderedLabel :text="t('show_dotted_line_label')" for="dottedLine">
      <input
          type="checkbox"
          name="dottedLine"
          id="dottedLine"
          :checked="currentSettings.dottedLine"
      />
    </CheckboxBorderedLabel>
    <div class="two-column">
      <table class="data-table">
        <thead>
        <tr>
          <th><input type="text" name="headerLeftCol" :value="currentSettings.headerLeftCol"></th>
          <th><input type="text" name="headerRightCol" :value="currentSettings.headerRightCol"></th>
        </tr>
        </thead>
        <tbody contenteditable="true" @input="serializeInput" ref="table" v-html="currentSettings.rows" class="table"
               @focusout="triggerSave">
        </tbody>
      </table>
      <table class="action-table">
        <thead>
        <tr>
          <th style="height: 2.1875rem; padding: 0.5rem; border: 1px solid transparent">&nbsp;</th>
        </tr>
        </thead>
        <tbody>
        <tr v-for="index in rowCount">
          <td>
            <button
                v-if="index % 2 === 1"
                @click.prevent="removeRow(index - 1)"
                class="button alert small"
            >&#x0078;
            </button>
            <p v-else style="padding: 0.25rem; margin: 0">&nbsp;</p>
          </td>
        </tr>
        </tbody>
      </table>
    </div>

    <button @click.prevent="addRow" class="button button">{{ t("add_row_button_label") }}</button>
    <input type="hidden" name="rows" id="rows" v-model="rowData" ref="rowData">
  </fieldset>
</template>

<script>
module.exports = {
  name: "mirros-widget-data-table",
  props: {
    currentSettings: {
      type: Object,
      required: true,
    },
    locale: {
      type: String,
      required: true
    }
  },
  data: function () {
    return {
      rowData: this.currentSettings.rows,
      rowCount: 0,
    }
  },
  mounted() {
    this.rowCount = this.$refs.table.rows.length;
  },
  methods: {
    async addRow() {
      ['text', 'details'].forEach(placeholder => {
        let row = document.createElement('tr');
        for (let i = 0; i < 2; i++) {
          let cell = row.insertCell();
          cell.innerText = i === 0 ? placeholder : ''
        }
        this.$refs.table.appendChild(row);
        this.rowCount++;
      });
      await this.serializeInput();
      this.triggerSave();
    },
    async removeRow(index) {
      /**
       * Remove main and sub rows. Index does not change as the first deleteRow call updates the
       * index, sub row is now at the same index.
       */
      for (let i = 0; i < 2; i++) {
        this.$refs.table.deleteRow(index);
        this.rowCount--;
      }
      await this.serializeInput();
      this.triggerSave();
    },
    async serializeInput() {
      this.rowData = this.$refs.table.innerHTML;
    },
    triggerSave() {
      this.$refs.rowData.dispatchEvent(new Event("change", {bubbles: true}));
    }
  },
  locales: {
    enGb: {
      show_column_headers_label: "Show column headers",
      show_dotted_line_label: "Show dotted line for main rows",
      add_row_button_label: "Add row"
    },
    deDe: {
      show_column_headers_label: "Spaltentitel anzeigen",
      show_dotted_line_label: "Gepunktete Linie für Hauptzeilen",
      add_row_button_label: "Zeile hinzufügen"
    },
    frFr: {
      show_column_headers_label: "Afficher les en-têtes de colonne",
      show_dotted_line_label: "Afficher la ligne pointillée pour les lignes principales",
      add_row_button_label: "Ajouter une ligne"
    },
    esEs: {
      show_column_headers_label: "Mostrar encabezados de columna",
      show_dotted_line_label: "Mostrar la línea de puntos para las filas principales\n",
      add_row_button_label: "Añadir fila"
    },
    plPl: {
      show_column_headers_label: "Pokaż nagłówki kolumn",
      show_dotted_line_label: "Pokaż przerywaną linię dla głównych rzędów",
      add_row_button_label: "Dodaj wiersz"
    },
    koKr: {
      show_column_headers_label: "열 머리글 보기",
      show_dotted_line_label: "주 행에 점선 표시",
      add_row_button_label: "행을 추가하세요"
    }
  }
}
</script>
<style scoped>
.two-column {
  display: grid;
  grid-template-columns: 95% 5%;
}

.data-table {
  user-select: text;
  border-collapse: collapse;
}

.data-table tbody {
  outline: none;
}

.action-table {
  table-layout: fixed;
  text-align: right;
  border-collapse: collapse;
}

.data-table td, .data-table th {
  border: 1px dashed grey;
}

.action-table :is(td, th) {
  border: 1px solid transparent;
}

.data-table td:last-of-type, .data-table th:last-of-type > input {
  text-align: right;
}

.data-table tr:nth-child(even) {
  font-size: smaller;
  height: 2.5rem;
  vertical-align: top;
}

.data-table tr:nth-child(4n),
.data-table tr:nth-child(4n-1) {
  background-color: rgba(139, 164, 193, 0.125);
}

.button {
  margin-top: 1rem;
}

.action-table .button {
  margin: 0;
}

thead input, thead input:focus {
  border: none;
  box-shadow: none;
  font-weight: bold;
  margin: 0;
  padding: 0;
}

table:is(.data-table, .action-table) :is(td, th) {
  padding: 0.25rem !important;
}
</style>
